#include "stdafx.h"
#include "app.h"
#include "IconComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


class CTestDialog : public CDialog
{
public:
//Constructors / Destructors
  CTestDialog(_In_opt_ CWnd* pParent = nullptr);
  CTestDialog(const CTestDialog&) = delete;
  CTestDialog(CTestDialog&&) = delete;
  ~CTestDialog() = default; //NOLINT(modernize-use-override)

//Member variables
  CTestDialog& operator=(const CTestDialog&) = delete;
  CTestDialog& operator=(CTestDialog&&) = delete;

protected:
//Member variables
  enum { IDD = IDD_MAINFRM };
  CSmallIconComboBox m_ctrlCombo1;
  UINT m_nIconID1;
  LPCTSTR m_pszIconID1;
  CLargeIconComboBox m_ctrlCombo2;
  UINT m_nIconID2;
  HICON m_hIcon;

//Methods
  void DoDataExchange(CDataExchange* pDX) override;
  BOOL OnInitDialog() override;

//Message handlers
  afx_msg HCURSOR OnQueryDragIcon();

  DECLARE_MESSAGE_MAP()
};


#pragma warning(suppress: 26455)
CTestDialog::CTestDialog(_In_opt_ CWnd* pParent) : CDialog{CTestDialog::IDD, pParent},
                                                   m_nIconID1{IDI_SMALL2},
                                                   m_pszIconID1{MAKEINTRESOURCE(IDI_SMALL2)},
                                                   m_nIconID2{IDI_BIG3},
                                                   m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CTestDialog::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_COMBO1, m_ctrlCombo1);
  DDX_CBIcon(pDX, IDC_COMBO1, m_nIconID1);
  DDX_CBIcon(pDX, IDC_COMBO1, m_pszIconID1);
  DDX_Control(pDX, IDC_COMBO2, m_ctrlCombo2);
  DDX_CBIcon(pDX, IDC_COMBO2, m_nIconID2);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestDialog, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()

#pragma warning(suppress: 26434 26440)
HCURSOR CTestDialog::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

BOOL CTestDialog::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  //Set up the dialog menu
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  //Set up the icons which are contained
  //within the icon combo boxes

  //Add all the small icons available
  m_ctrlCombo1.AddIcon(IDI_SMALL1);
  m_ctrlCombo1.InsertIcon(0, IDI_SMALL2); //Note the following 3 lines are just to exercise the InsertIcon & DeleteIcon methods
  const int nIndex{m_ctrlCombo1.AddIcon(IDI_SMALL2)};
  m_ctrlCombo1.DeleteIcon(nIndex);
  m_ctrlCombo1.AddIcon(IDI_SMALL3);
  m_ctrlCombo1.AddIcon(IDI_SMALL4);
  m_ctrlCombo1.AddIcon(IDI_SMALL5);
  m_ctrlCombo1.AddIcon(IDI_SMALL6);
  m_ctrlCombo1.AddIcon(IDI_SMALL7);
  m_ctrlCombo1.AddIcon(IDI_SMALL8);
  
  //Add all the large icons available
  m_ctrlCombo2.AddIcon(IDI_BIG1);
  m_ctrlCombo2.AddIcon(IDI_BIG2);
  m_ctrlCombo2.AddIcon(IDI_BIG3);
  m_ctrlCombo2.AddIcon(IDI_BIG4);

  //Force a DoDataExchange after adding the icons to the combo boxes
  UpdateData(FALSE);

  return TRUE;
}

#pragma warning(suppress: 26426)
CTestApp theApp;

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestApp, CWinApp) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

BOOL CTestApp::InitInstance()
{
  //Bring up the test dialog
  CTestDialog dlg;
  dlg.DoModal();

  return FALSE;
}
